﻿// JScript File
        var map = null;
         var pinID = 1;
         var primeZipcode;
         var zipCount = 0;
         var veColors = new Array();
         var numColors = 10;
         var startTime = new Date();
         var numShapes;
         var spatialDemoState = 0;
         var numStates = 4;
         var site = 0; //default to ZipCode demo
         var oldLat;
         var oldLon;
         var lat;
         var lon;
         var pushpinUrl = null;
            
         var hostname;  
            
       function DrawZip()
       {
            zipcode = document.zipform.txtzipcode.value;
            GetZipCode(zipcode);
       }
          
         function GetMap()
         {
            map = new VEMap('zipMap');
            map.LoadMap();
            InitColors();
            hostname = "http://" + window.location.hostname + "/";
         }   
         
         function ClearMap()
         {
            map.DeleteAllPushpins();
            map.DeleteAllPolygons();
            map.DeleteAllPolylines();
         }
         
         //Standard AJAX functions
            var req;
          function loadXMLDoc(url) {
             req = false;
             if(window.XMLHttpRequest) {
                       req = new XMLHttpRequest();
              // branch for IE/Windows ActiveX version
              } else if(window.ActiveXObject) {
                          req = new ActiveXObject("Microsoft.XMLHTTP");
              }
              if(req) {
                      req.onreadystatechange = ProcessReqChange;
                         req.open("GET", url, true);
                         req.send(null);
              }
              else
              {
                document.zipform.status.value = "error in loadxmldoc";
              }
          }

          function ProcessReqChange() {
              // only if req shows "loaded"
                
              if (req.readyState == 4) {
                  // only if "OK"
                  if (req.status == 200) 
                  {
                     var doc  = req.responseXML;        
                     if(doc.documentElement.nodeName == "ShapeCollection")
                     {
                         if(site > 1)
                         {
                           document.getElementById("Instructions").innerText = spatialDemoLabels[spatialDemoState];
                           document.getElementById("Title").innerText = spatialDemoTitles[spatialDemoState];
                           map.SetCenterAndZoom(new VELatLong(lat, lon), spatialDemoZooms[spatialDemoState]);
                         }
                           document.zipform.status.value = "Processing Data";
                           ProcessShapeCollection(doc);
                     }
                     else {
                      document.zipform.status.value = "ZipCode not found";
                      if(site>1)
                        document.getElementById("Instructions").innerText = "No Data Available for Region";
                     }
                  }
                  else {
                  document.zipform.status.value = "Problem connecting to database";
                  //alert(req.statusText);
                  }
              }
          }
         
         function ProcessShapeCollection(xmlDoc)
         {
            //document.zipform.status.value = "in ShapeCollection";
            var shapes = xmlDoc.getElementsByTagName("shape");
            numShapes = shapes.length;
            for(var i = 0; i < numShapes; i++)
            {
                ProcessShape(shapes[i]);
            }
            if(numShapes == 0 && site > 1)
                document.getElementById("Instructions").innerText = "No Data Available for Region";   
         }
         
         function ProcessShape(xmlDoc)
         {
            zipCount++;
            var name = xmlDoc.childNodes[0].text;
            var gtype = xmlDoc.childNodes[1].text;
            var color = veColors[10];
            var pushpin = xmlDoc.childNodes[2];
            if(pushpin.text != "")
            {
                var data = xmlDoc.childNodes[3].text;
                var vePin = new VEPushpin(name + "_" + zipCount, 
                                new VELatLong(pushpin.childNodes[0].text, pushpin.childNodes[1].text),
                                pushpinUrl,
                                name,
                                data,
                                'iconStyle',
                                'pushpinTitleStyle',
                                'pushpinDetailsStyle');
                map.AddPushpin(vePin);                    
            }
            var colorInt = xmlDoc.childNodes[4].text;
            if(colorInt != "")
            {
                colorInt = Math.floor(colorInt * (numColors/numShapes));
                color = veColors[colorInt];
            }
            
            var points = xmlDoc.lastChild.getElementsByTagName("point");
            var numPoints = points.length;
            if(numPoints > 0)
            {
                var vePoints = new Array(numPoints);
                for(var i = 0; i < numPoints; i++)
                {
                    vePoints[i] = new VELatLong(points[i].childNodes[0].text, points[i].childNodes[1].text);
                }
                if(gtype==2)
                    AddPolygon(vePoints, name, color);
                else if(gtype==1)
                    AddPolyline(vePoints, name, color);
                if(site==0) //For zipcode demo, zoom in on the displayed object
                    map.SetMapView(vePoints);
            }
         }
         
         function GetShapeById(zipcode)
         {
            ClearMap();
            zipCount = 0;
            primeZipcode = zipcode;
            var s;
            for(var i = 0; i < document.zipform.RegionType.length;i++)
            {
                if(document.zipform.RegionType[i].checked)
                    s=document.zipform.RegionType[i].value;
            }
                var url = hostname + "SpatialDemo/SpatialMethods.asmx/GetShapeById?id="+zipcode+"&s="+s;
                if(document.zipform.chktouching.checked)
                    url = url + "&t=1";
                else
                    url = url + "&t=0";   
                if(document.zipform.chkindex.checked)
                    url = url + "&i=1";
                else
                    url = url + "&i=0";
                loadXMLDoc(url);
                document.zipform.status.value="working";
                 if(s == 0)
                    document.getElementById("query").innerText = "select id, shape.ToString() from zipcodes where id=@inputId";   
                 else if(s== 1)
                    document.getElementById("query").innerText = "select id, shape.ToString() from census where id=@inputId";   
                 else if(s== 2)
                    document.getElementById("query").innerText = "select id, shape.ToString() from congress where id=@inputId";   
             
         }
         
          function GetShapeByClick(e)
        {
            ClearMap();
            zipCount = 0;
            primeZipcode = -1;
            var s;
            //Determine which RadioButton is selected
            for(var i = 0; i < document.zipform.RegionType.length;i++)
            {
                if(document.zipform.RegionType[i].checked)
                    s=document.zipform.RegionType[i].value;
            }
            var url = hostname + "SpatialDemo/SpatialMethods.asmx/GetShapeByLatLong?lat="+e.view.LatLong.Latitude+"&lon="+e.view.LatLong.Longitude+"&s="+s;
            if(document.zipform.chkindex.checked)
                url = url + "&i=1";
            else
                url = url + "&i=0";
            document.zipform.status.value="working";
            loadXMLDoc(url);
               if(s == 0)
                    document.getElementById("query").innerText = "select id, shape.ToString() from zipcodes where shape.STIntersects(@clickedPoint)=1";   
                 else if(s== 1)
                    document.getElementById("query").innerText = "select id, shape.ToString() from census where shape.STIntersects(@clickedPoint)=1";   
                 else if(s== 2)
                    document.getElementById("query").innerText = "select id, shape.ToString() from congress where shape.STIntersects(@clickedPoint)=1";   
        }
        
        function RunQuery(query, iconType)
        {
         if (typeof iconType != "undefined") {
            if(iconType == 0)
            {
                ClearMap();
                pushpinUrl = null;
            }
            else if(iconType == 1)
                pushpinUrl = 'pin2.gif';
         }
         else
         {
            ClearMap();
         }

            
            zipCount = 0;
            primeZipcode = -1;

            var url = hostname + "ShapeService.asmx/RunQuery?query="+encodeURIComponent(query);
            document.zipform.status.value="working";
            loadXMLDoc(url);
        }

       
         
         function AddPolygon(points, name, color)
         {   
            
           poly = new VEPolygon(name+"_"+zipCount,points);
           poly.SetOutlineWidth(2);
           poly.SetFillColor(color);
           if(name==primeZipcode || primeZipcode == -1)
           {
            document.zipform.status.value="Drawing: " + name;
            poly.SetOutlineColor(new VEColor(0,0,0,.8));
           }
           else
           {
            poly.SetOutlineColor(new VEColor(0,50,200,1.0));
           }
           map.AddPolygon(poly);
         } 
         
         function AddPolyline(points, name, color)
         {   
            zipCount++;
           poly = new VEPolyline(name+"_"+zipCount,points);
           poly.SetWidth(2);
           poly.SetColor(color);
           map.AddPolyline(poly);
         }    
         
         function AddPushpin(points, name)
         {   
            //map.AddPushpin();
         }    


       function SalesLoad(e)
       {
       GetMap();
        site = 5;
       }

       /******************************************************************************
       /* Default (ZipCode) functions
       *******************************************************************************/    
       function CustomLoad(e)
       {
       GetMap();
        site = 1;
       }
       
       function ZipLoad(e)
        {
            GetMap();
            site = 0;
            map.AttachEvent("onmousedown", MouseDown);
            map.AttachEvent("onmouseup", MouseUp);
        }
       
         function MouseClick(e)
         {
           GetShapeByClick(e);
         }
         
         function MouseDown(e)
         {
            startTime = new Date();
         }
         
         function MouseUp(e)
         {
            var endTime = new Date();
            if(endTime.getTime() - startTime.getTime() < 400) //single click
                GetShapeByClick(e);
         }
         
function InitColors()
{
    var i = 0;
    veColors[i] = new VEColor(255,255,255,0.5); i++; //White
    veColors[i] = new VEColor(255, 231, 231,0.8); i++; //VeryLight Red
    veColors[i] = new VEColor(255, 202, 202,0.8); i++; //Light Red
    veColors[i] = new VEColor(255, 171, 171,0.8); i++; //Light-Medium Red
    veColors[i] = new VEColor(255, 143, 143,0.8); i++; //Medium Red
    veColors[i] = new VEColor(255, 115, 115,0.8); i++; //Medium-Bright Red
    veColors[i] = new VEColor(255, 84, 84,0.8); i++; //Bright Red
    veColors[i] = new VEColor(255, 57, 57,0.8); i++; //Bright Red
    veColors[i] = new VEColor(255, 29, 29,0.8); i++; //Bright Red
    veColors[i] = new VEColor(255, 0, 0,0.8); i++; //Bright-Dark Red
    //veColors[i] = new VEColor(207, 7, 28,0.8); i++; //Dark Red
    //veColors[i] = new VEColor(174, 7, 28,0.8); i++; //VeryDark Red
    veColors[i] = new VEColor(0,150,180,0.8); i++; //Green
    veColors[i] = new VEColor(0,50,180,0.8); i++; //Blue
}